diff -r 2a700fc24c59 src/Editor.cxx
--- a/src/Editor.cxx	Wed Nov 10 09:52:11 2021 +1100
+++ b/src/Editor.cxx	Wed Nov 10 16:28:49 2021 +1100
@@ -5888,7 +5888,7 @@
 
 	case Message::GetText: {
 			if (lParam == 0)
-				return pdoc->Length() + 1;
+				return pdoc->Length();
 			if (wParam == 0)
 				return 0;
 			char *ptr = CharPtrFromSPtr(lParam);
@@ -6034,16 +6034,14 @@
 			SelectionText selectedText;
 			CopySelectionRange(&selectedText);
 			if (lParam == 0) {
-				return selectedText.LengthWithTerminator();
+				return selectedText.Length();
 			} else {
 				char *ptr = CharPtrFromSPtr(lParam);
 				size_t iChar = selectedText.Length();
 				if (iChar) {
 					memcpy(ptr, selectedText.Data(), iChar);
-					ptr[iChar++] = '\0';
-				} else {
-					ptr[0] = '\0';
 				}
+				ptr[iChar] = '\0';
 				return iChar;
 			}
 		}
@@ -6554,11 +6552,10 @@
 			const Sci::Position lineStart = pdoc->LineStart(lineCurrentPos);
 			const Sci::Position lineEnd = pdoc->LineStart(lineCurrentPos + 1);
 			if (lParam == 0) {
-				return 1 + lineEnd - lineStart;
+				return lineEnd - lineStart;
 			}
-			PLATFORM_ASSERT(wParam > 0);
 			char *ptr = CharPtrFromSPtr(lParam);
-			const Sci::Position len = std::min<uptr_t>(lineEnd - lineStart, wParam - 1);
+			const Sci::Position len = std::min<uptr_t>(lineEnd - lineStart, wParam);
 			pdoc->GetCharRange(ptr, lineStart, len);
 			ptr[len] = '\0';
 			return sel.MainCaret() - lineStart;
diff -r 2a700fc24c59 test/simpleTests.py
--- a/test/simpleTests.py	Wed Nov 10 09:52:11 2021 +1100
+++ b/test/simpleTests.py	Wed Nov 10 16:28:49 2021 +1100
@@ -128,7 +128,7 @@
 		self.assertEquals(self.ed.SelectionStart, 1)
 		self.assertEquals(self.ed.SelectionEnd, 3)
 		result = self.ed.GetSelText(0)
-		self.assertEquals(result, b"bc\0")
+		self.assertEquals(result, b"bc")
 		self.ed.ReplaceSel(0, b"1234")
 		self.assertEquals(self.ed.Length, 6)
 		self.assertEquals(self.ed.Contents(), b"a1234d")
